<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: VirtualEnvironment</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href=".././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">VirtualEnvironment</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../files/app/models/virtual_environment_rb.html">
                app/models/virtual_environment.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                ActiveRecord::Base
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">



   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000014">all_possible</a>&nbsp;&nbsp;
      <a href="#M000016">free_ip</a>&nbsp;&nbsp;
      <a href="#M000015">grab_available_ip</a>&nbsp;&nbsp;
      <a href="#M000017">grab_available_veid</a>&nbsp;&nbsp;
      <a href="#M000018">validate</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->

    <div id="section">





      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000014" class="method-detail">
        <a name="M000014"></a>

        <div class="method-heading">
          <a href="#M000014" class="method-signature">
          <span class="method-name">all_possible</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000014-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000014-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/virtual_environment.rb, line 4</span>
 4:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">all_possible</span>
 5:     <span class="ruby-identifier">out</span> = []
 6:     <span class="ruby-constant">IP_RANGE</span>.<span class="ruby-identifier">to_a</span>.<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">ip_end</span><span class="ruby-operator">|</span> 
 7:       <span class="ruby-identifier">out</span> <span class="ruby-operator">&lt;&lt;</span> 
 8:         (<span class="ruby-constant">IP_BEGINNING</span>.<span class="ruby-identifier">to_s</span> <span class="ruby-operator">+</span> <span class="ruby-identifier">ip_end</span>.<span class="ruby-identifier">to_s</span>)
 9:     <span class="ruby-keyword kw">end</span>
10:     <span class="ruby-identifier">out</span>
11:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000016" class="method-detail">
        <a name="M000016"></a>

        <div class="method-heading">
          <a href="#M000016" class="method-signature">
          <span class="method-name">free_ip</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000016-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000016-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/virtual_environment.rb, line 33</span>
33:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">free_ip</span>
34:     
35:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000015" class="method-detail">
        <a name="M000015"></a>

        <div class="method-heading">
          <a href="#M000015" class="method-signature">
          <span class="method-name">grab_available_ip</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000015-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000015-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/virtual_environment.rb, line 13</span>
13:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">grab_available_ip</span>
14:     <span class="ruby-identifier">current_ips</span> =
15:       <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">find_all_by_status</span>(<span class="ruby-value str">'started'</span>).<span class="ruby-identifier">collect</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span> <span class="ruby-identifier">v</span> <span class="ruby-operator">|</span>
16:       <span class="ruby-identifier">v</span>.<span class="ruby-identifier">ip</span>
17:     <span class="ruby-keyword kw">end</span>
18:     
19:     <span class="ruby-identifier">all_available</span> = <span class="ruby-identifier">all_possible</span>.<span class="ruby-identifier">collect</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">ip</span><span class="ruby-operator">|</span>
20:       <span class="ruby-identifier">ip</span> <span class="ruby-keyword kw">unless</span> <span class="ruby-identifier">current_ips</span>.<span class="ruby-identifier">include?</span>(<span class="ruby-identifier">ip</span>)
21:     <span class="ruby-keyword kw">end</span>
22:     
23:     <span class="ruby-identifier">all_available</span>.<span class="ruby-identifier">compact!</span>
24: 
25:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">all_available</span>.<span class="ruby-identifier">empty?</span>
26:       <span class="ruby-identifier">raise</span> <span class="ruby-value str">&quot;No more IPs&quot;</span>
27:     <span class="ruby-keyword kw">else</span>
28:       <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">ip</span> = <span class="ruby-identifier">all_available</span>[<span class="ruby-value">0</span>]
29:       <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">save!</span>
30:     <span class="ruby-keyword kw">end</span>
31:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000017" class="method-detail">
        <a name="M000017"></a>

        <div class="method-heading">
          <a href="#M000017" class="method-signature">
          <span class="method-name">grab_available_veid</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000017-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000017-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/virtual_environment.rb, line 37</span>
37:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">grab_available_veid</span>
38:     <span class="ruby-identifier">last_ve</span> = 
39:       <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">find_by_uid</span>(<span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">uid</span>, 
40:                                      <span class="ruby-identifier">:order</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">&quot;veid DESC&quot;</span>)
41:     <span class="ruby-identifier">first_destroyed_ve</span> = 
42:       <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">find_by_uid_and_status</span>(<span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">uid</span>, 
43:                                                 <span class="ruby-value str">'destroyed'</span>, 
44:                                                 <span class="ruby-identifier">:order</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">&quot;veid&quot;</span>)
45:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">last_ve</span>.<span class="ruby-identifier">nil?</span>
46:       <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">veid</span> = (<span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">uid</span>.<span class="ruby-identifier">to_s</span> <span class="ruby-operator">+</span> <span class="ruby-value str">'01'</span>).<span class="ruby-identifier">to_i</span>
47:     <span class="ruby-keyword kw">else</span>
48:       <span class="ruby-identifier">last_two_digits</span> = <span class="ruby-identifier">last_ve</span>.<span class="ruby-identifier">veid</span>.<span class="ruby-identifier">to_s</span>[<span class="ruby-value">-2</span><span class="ruby-operator">..</span><span class="ruby-value">-1</span>]
49:       
50:       <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">last_two_digits</span> <span class="ruby-operator">==</span> <span class="ruby-value str">'99'</span>
51:         <span class="ruby-identifier">raise</span> <span class="ruby-value str">&quot;Last VE is VE 99 and &quot;</span> <span class="ruby-operator">+</span>
52:           <span class="ruby-value str">&quot;no destroyed VEs found.&quot;</span> <span class="ruby-keyword kw">unless</span> <span class="ruby-identifier">first_destroyed_ve</span>
53:         <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">veid</span> = <span class="ruby-identifier">first_destroyed_ve</span>.<span class="ruby-identifier">veid</span>
54:       <span class="ruby-keyword kw">else</span> 
55:         <span class="ruby-identifier">next_number</span> = <span class="ruby-identifier">last_two_digits</span>.<span class="ruby-identifier">to_i</span> <span class="ruby-operator">+</span> <span class="ruby-value">1</span>
56:         <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">veid</span> = (<span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">uid</span>.<span class="ruby-identifier">to_s</span> <span class="ruby-operator">+</span> <span class="ruby-identifier">next_number</span>.<span class="ruby-identifier">to_s</span>.<span class="ruby-identifier">rjust</span>(<span class="ruby-value">2</span>, <span class="ruby-value str">'0'</span>)).<span class="ruby-identifier">to_i</span>
57:       <span class="ruby-keyword kw">end</span>
58:     <span class="ruby-keyword kw">end</span>
59:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <h3 class="section-bar">Protected Instance methods</h3>

      <div id="method-M000018" class="method-detail">
        <a name="M000018"></a>

        <div class="method-heading">
          <a href="#M000018" class="method-signature">
          <span class="method-name">validate</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
validates_uniqueness_of(:ip) but allow it to be nil
</p>
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000018-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000018-source">
<pre>
     <span class="ruby-comment cmt"># File app/models/virtual_environment.rb, line 69</span>
 69:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">validate</span>
 70: 
 71:     <span class="ruby-comment cmt"># # Old Way</span>
 72:     <span class="ruby-comment cmt">#preset_values = ['starting', 'running', </span>
 73:     <span class="ruby-comment cmt">#                 'creating', 'stopping', 'stopped',</span>
 74:     <span class="ruby-comment cmt">#                 'destroying', 'destroyed', </span>
 75:     <span class="ruby-comment cmt">#                 'mounted']</span>
 76: 
 77:     <span class="ruby-comment cmt"># New Way</span>
 78:     <span class="ruby-identifier">preset_values</span> = [<span class="ruby-value str">'creating'</span>,
 79: 
 80:                      <span class="ruby-value str">'stopped'</span>,
 81:                      <span class="ruby-value str">'started'</span>,
 82:                      <span class="ruby-value str">'destroyed'</span>, 
 83: 
 84:                      <span class="ruby-value str">'mounted'</span>]
 85: 
 86:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:status</span>, <span class="ruby-value str">&quot;should be one of the preset values &quot;</span> <span class="ruby-operator">+</span>
 87:                <span class="ruby-identifier">preset_values</span>.<span class="ruby-identifier">inspect</span>) <span class="ruby-keyword kw">unless</span>
 88:       <span class="ruby-identifier">preset_values</span>.<span class="ruby-identifier">include?</span>(<span class="ruby-identifier">status</span>)
 89: 
 90:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:veid</span>, <span class="ruby-value str">&quot;should begin with the uid&quot;</span>) <span class="ruby-keyword kw">unless</span>
 91:       <span class="ruby-identifier">veid</span>.<span class="ruby-identifier">to_s</span> <span class="ruby-operator">=~</span> <span class="ruby-node">/^#{uid}([[:digit:]]{2})$/</span>
 92: 
 93:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:uid</span>, <span class="ruby-value str">&quot;should be positive&quot;</span>) <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">uid</span>.<span class="ruby-identifier">nil?</span> <span class="ruby-operator">||</span> <span class="ruby-identifier">uid</span> <span class="ruby-operator">&lt;=</span> <span class="ruby-value">0</span>
 94:     
 95:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:status</span>, <span class="ruby-value str">&quot;should not be nil&quot;</span>) <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">status</span>.<span class="ruby-identifier">nil?</span> 
 96: 
 97:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:template_id</span>, <span class="ruby-value str">&quot;should be an existing one&quot;</span>) <span class="ruby-keyword kw">if</span> 
 98:       <span class="ruby-constant">OpenvzTemplate</span>.<span class="ruby-identifier">exists?</span>(<span class="ruby-identifier">template_id</span>) <span class="ruby-operator">==</span> <span class="ruby-keyword kw">false</span>
 99:     
100:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:ip</span>, <span class="ruby-value str">&quot;should be within the configured range&quot;</span>) <span class="ruby-keyword kw">unless</span>
101:       <span class="ruby-identifier">all_possible</span>.<span class="ruby-identifier">include?</span>(<span class="ruby-identifier">ip</span>) <span class="ruby-operator">||</span> <span class="ruby-identifier">ip</span>.<span class="ruby-identifier">nil?</span>
102: 
103:     <span class="ruby-identifier">errors</span>.<span class="ruby-identifier">add</span>(<span class="ruby-identifier">:setup_needed</span>, <span class="ruby-value str">&quot;should be boolean&quot;</span>) <span class="ruby-keyword kw">unless</span>
104:       [<span class="ruby-constant">TrueClass</span>, <span class="ruby-constant">FalseClass</span>].<span class="ruby-identifier">include?</span> <span class="ruby-identifier">setup_needed</span>.<span class="ruby-identifier">class</span>
105:     
106:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>